function load_config()
	if glob.gt_extra_item_values == nil then
		glob.gt_extra_item_values = {}
	end
	if glob.gt_extra_smelted_items == nil then
		glob.gt_extra_smelted_items = {}
	end
	if glob.gt_extra_blacklist == nil then
		glob.gt_extra_blacklist = {}
	end

	-- You shouldn't touch anything above this line --

	glob.gt_initial_supply_modifier = glob.gt_initial_supply_modifier or 1000 --determines how much supply there is with items (based on this number and value)
	glob.gt_items_per_row = glob.gt_items_per_row or 20 --items per row in buying trading chest gui, if there are more than 20 rows, there will be a new page
	glob.gt_items_per_collum = 5 --items per row in buying trading chest gui
	glob.gt_reload_item_values_on_load = false --only do this if you want to change item values, makes load times longer if left on. Eventually there will be a button for it
	glob.gt_instant_buy_button_enabled = false
	glob.gt_starting_credits = 0
	glob.gt_max_factory_initial_size = 50
	glob.gt_enable_trade_alert = true
	--Dynamic economies aren't ready yet
	--glob.gt_dynamic_economy = true --enables the economy to be dependent on factories and consumers that provide a supply and demand
	glob.gt_previous_version_support = true --possible that it conflicts with other mods
	glob.gt_transaction_history_limit = 100 -- higher the number the more RAM it uses (and larger save file size)

	--mod support, change to true for any mods you want support for
	gt_NEARMod_values_support = false
	gt_DytechMod_values_support = false --WARNING these values may not be balanced and may need to be modified

	--add raw resource values here (items which don't have crafting recipies) with their values, see examples below

	--glob.gt_extra_item_values["gold-ore"] = 100 -- this is an example for gold ore (make sure you put the item's name that is shown in the lua files, not from in-game, it could be different)


	--glob.gt_extra_smelted_items["gold-plate"] = true --this says that gold plate is smelted, which adds a little value to it for the fuel cost (the true is just to make my life a little easier)

	--glob.gt_extra_blacklist["gold-plate"] = true -- this is if you don't want an item you can buy or sell, this example says that gold plate wont be able to be bought or sold


	if gt_NEARMod_values_support then
		
		glob.gt_extra_item_values["gold-ore"] = 100
		glob.gt_extra_item_values["lead-ore"] = 30
		glob.gt_extra_item_values["tungsten-ore"] = 70
		glob.gt_extra_item_values["zinc-ore"] = 50
		glob.gt_extra_item_values["tin-ore"] = 50
		glob.gt_extra_item_values["bauxite-ore"] = 15
		glob.gt_extra_item_values["rutile-ore"] = 200
		glob.gt_extra_item_values["nitrogen-gas"] = 1
		glob.gt_extra_item_values["oxygen-gas"] = 5
		glob.gt_extra_item_values["argon-gas"] = 50
		glob.gt_extra_item_values["co2-gas"] = 4   
		glob.gt_extra_item_values["hydrogen-gas"] = 15
		glob.gt_extra_item_values["sodium-hydroxide"] = 8
		glob.gt_extra_item_values["bromine"] = 8
		glob.gt_extra_item_values["ferric-chloride-solution"] = 15
		glob.gt_extra_item_values["chlorine"] = 7
		glob.gt_extra_item_values["cobalt-oxide"] = 70
		glob.gt_extra_item_values["gold-plate"] = 200
		glob.gt_extra_item_values["dry-ice"] = 1
		glob.gt_extra_item_values["quartz"] = 30
		glob.gt_extra_item_values["brine-water"] = 5

		glob.gt_extra_smelted_items["tin-plate"]=true
		glob.gt_extra_smelted_items["lead-plate"]=true
		glob.gt_extra_smelted_items["zinc-plate"]=true
		glob.gt_extra_smelted_items["titan-plate"]=true
		glob.gt_extra_smelted_items["copper-tungsten-plate"]=true
		glob.gt_extra_smelted_items["tungsten-carbide-plate"]=true
		glob.gt_extra_smelted_items["aluminium-plate"]=true
		glob.gt_extra_smelted_items["bronze-plate"]=true
		glob.gt_extra_smelted_items["gold-plate"] = true
		
	end

	if gt_DytechMod_values_support then
		--WARNING these values may not be balanced and may need to be modified
		
		glob.gt_extra_item_values["diamond-orex"] = 250
		glob.gt_extra_item_values["emerald-orex"] = 250
		glob.gt_extra_item_values["ruby-orex"] = 250
		glob.gt_extra_item_values["sapphire-orex"] = 250
		glob.gt_extra_item_values["topaz-orex"] = 250
		glob.gt_extra_item_values["diamond-ore"] = 200
		glob.gt_extra_item_values["emerald-ore"] = 200
		glob.gt_extra_item_values["ruby-ore"] = 200
		glob.gt_extra_item_values["sapphire-ore"] = 200
		glob.gt_extra_item_values["topaz-ore"] = 200
		glob.gt_extra_item_values["resin"] = 50
		glob.gt_extra_item_values["obsidian"] = 100
		glob.gt_extra_item_values["bone"] = 50
		glob.gt_extra_item_values["chitin"] = 50
		glob.gt_extra_item_values["ardite-ore"] = 75
		glob.gt_extra_item_values["cobalt-ore"] = 75
		glob.gt_extra_item_values["gold-ore"] = 250
		glob.gt_extra_item_values["lead-ore"] = 250
		glob.gt_extra_item_values["silver-ore"] = 105
		glob.gt_extra_item_values["tin-ore"] = 100
		glob.gt_extra_item_values["tungsten-ore"] = 100
		glob.gt_extra_item_values["zinc-ore"] = 100
		glob.gt_extra_item_values["brick"] = 100
		glob.gt_extra_item_values["carbon"] = 100
		glob.gt_extra_item_values["silicon"] = 50
		glob.gt_extra_item_values["sand"] = 10
		glob.gt_extra_item_values["sulfur-wood"] = 15
		glob.gt_extra_smelted_items["lead-plate"] = true
		glob.gt_extra_smelted_items["silver-plate"] = true
		glob.gt_extra_smelted_items["tin-plate"] = true
		glob.gt_extra_smelted_items["tungsten-plate"] = true
		glob.gt_extra_smelted_items["zinc-plate"] = true
		glob.gt_extra_smelted_items["brick"] = true
		glob.gt_extra_smelted_items["glass"] = true
		glob.gt_extra_smelted_items["ardite-plate"] = true
		glob.gt_extra_smelted_items["cobalt-plate"] = true
		glob.gt_extra_smelted_items["gold-plate"] = true
	end
end